diff -durN asterisk.orig/funcs/func_odbc.c asterisk/funcs/func_odbc.c
--- asterisk.orig/funcs/func_odbc.c	2019-08-06 16:13:33.000000000 +1000
+++ asterisk/funcs/func_odbc.c	2019-08-07 11:17:58.409693000 +1000
@@ -921,13 +921,18 @@
 			if (y == 0) {
 				char colname[256];
 				SQLULEN maxcol = 0;
+				SQLSMALLINT coltype;
 
-				res = SQLDescribeCol(stmt, x + 1, (unsigned char *)colname, sizeof(colname), &collength, NULL, &maxcol, NULL, NULL);
+				res = SQLDescribeCol(stmt, x + 1, (unsigned char *)colname, sizeof(colname), &collength, &coltype, &maxcol, NULL, NULL);
 				ast_debug(3, "Got collength of %d and maxcol of %d for column '%s' (offset %d)\n", (int)collength, (int)maxcol, colname, x);
 				if (((res != SQL_SUCCESS) && (res != SQL_SUCCESS_WITH_INFO)) || collength == 0) {
 					snprintf(colname, sizeof(colname), "field%d", x);
 				}
 
+				if ((coltype <= SQL_WCHAR) && (coltype >= SQL_WLONGVARCHAR)) {
+					maxcol = maxcol * 2;
+				}
+
 				ast_str_make_space(&coldata, maxcol + 1);
 
 				if (ast_str_strlen(colnames)) {
@@ -1497,7 +1502,7 @@
 		int dsn_num, executed = 0;
 		SQLHSTMT stmt;
 		int rows = 0, res, x;
-		SQLSMALLINT colcount = 0, collength;
+		SQLSMALLINT colcount = 0, collength, coltype;
 		SQLLEN indicator;
 		struct ast_str *coldata = ast_str_thread_get(&coldata_buf, 16);
 		char colname[256];
@@ -1562,12 +1567,17 @@
 				for (x = 0; x < colcount; x++) {
 					maxcol = 0;
 
-					res = SQLDescribeCol(stmt, x + 1, (unsigned char *)colname, sizeof(colname), &collength, NULL, &maxcol, NULL, NULL);
+					res = SQLDescribeCol(stmt, x + 1, (unsigned char *)colname, sizeof(colname), &collength, &coltype, &maxcol, NULL, NULL);
 					if (((res != SQL_SUCCESS) && (res != SQL_SUCCESS_WITH_INFO)) || collength == 0) {
 						snprintf(colname, sizeof(colname), "field%d", x);
 					}
 
+					if ((coltype <= SQL_WCHAR) && (coltype >= SQL_WLONGVARCHAR)) {
+						maxcol = maxcol * 2;
+					}
+
 					res = ast_odbc_ast_str_SQLGetData(&coldata, maxcol, stmt, x + 1, SQL_CHAR, &indicator);
+
 					if (indicator == SQL_NULL_DATA) {
 						ast_str_set(&coldata, 0, "(nil)");
 						res = SQL_SUCCESS;
